eval3/config/routes.rb
Eval3::Application.routes.draw do
  resources :execution

	resources :definition

	resources :query

	get 'definition/:id/new' => 'definition#new', as: :id

end

eval3/app/models/definition.rb
class Definition < ActiveRecord::Base
	validates_presence_of :text, :sandbox_id, :hidden_sandbox_id, :label

	has_many :children, :class_name => "Definition", :foreign_key => "parent_id"
	belongs_to :parent, :class_name => "Definition"
	has_one :sandbox
	has_one :hidden_sandbox
	has_many :query

	attr_accessible :parent, :parent_id, :text, :sandbox_id, :hidden_sandbox_id, :label

	accepts_nested_attributes_for :parent

#/*
=begin
napriklad takto

 has_many :bb,
 :class_name => "XxxYyy",
 :foreign_key => :xx_id,
 :dependent => :destroy
 has_many :aa,
 :through => :bb,
 :source => :aa
=end
#*/


end

eval3/app/models/execution.rb
class Execution < ActiveRecord::Base
	belongs_to :definition, class_name: "Definition"
	belongs_to :query, class_name: "Query"
end

eval3/app/models/query.rb
class Query < ActiveRecord::Base
	has_one :author
	has_one :definition
	has_many :execution

	attr_accessible :sql, :author_id, :purpose, :definition_id
end

eval3/app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception
end

eval3/app/controllers/definition_controller.rb
class DefinitionController < ApplicationController
  before_action :set_definition, only: [:show, :edit, :update, :destroy]

  # GET /definition
  # GET /definition.json
  def index
    @definition = Definition.all
  end

  # GET /definition/1
  # GET /definition/1.json
  def show
	@definition = Definition.find_by_id(params[:id])
	@all_subdefinition = @definition.children.all
	@query_solution = Query.where(definition_id: params[:id],
					purpose: "SOLUTION");
	@query_table = Query.where(	definition_id: params[:id],
					purpose: "TABLE");
	@query_umlimage = Query.where(definition_id: params[:id],
					purpose: "UMLCLASS");
	@execution_solution = Execution.where(query_id: @query_solution.first.id)
	@execution_table = Execution.where(query_id: @query_table.first.id)
	@execution_umlimage = Execution.where(query_id: @query_umlimage.first.id)
	if nil == @query_solution
	@query_solution = []
	end
	if nil == @query_table
	@query_table = []
	end
	if nil == @query_umlimage
	@query_umlimage = []
	end
  end

  # GET /definition/new params[:id]
  def new
	@par = Definition.find_by_id(params[:id])
	if nil == @par
	@par = Definition.find_by_id("1")
	end
	@definition = Definition.new(	:parent_id => @par.id,
					:sandbox_id => @par.sandbox_id,
					:hidden_sandbox_id => @par.hidden_sandbox_id)

  end

  # GET /definition/1/edit
  def edit
	@definition = Definition.find(params[:id])
  end

  # POST /definition
  # POST /definition.json
  def create
    @definition = Definition.new(definition_params)

    respond_to do |format|
      if @definition.save
        format.html { redirect_to @definition, notice: 'Definition was successfully created.' }
        format.json { render action: 'show', status: :created, location: @definition }
      else
        format.html { render action: 'new' }
        format.json { render json: @definition.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /definition/1
  # PATCH/PUT /definition/1.json
  def update
    respond_to do |format|
      if @definition.update(definition_params)
        format.html { redirect_to @definition, notice: 'Definition was successfully updated.' }
        format.json { head :no_content }
      else
        format.html { render action: 'edit' }
        format.json { render json: @definition.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /definition/1
  # DELETE /definition/1.json
  def destroy
	if "1" != @definition.id
		@definition.destroy
	end
    respond_to do |format|
      format.html { redirect_to definition_index_url }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_definition
      @definition = Definition.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def definition_params
      params[:definition]
    end
end

eval3/app/controllers/execution_controller.rb
class ExecutionController < ApplicationController
  before_action :set_execution, only: [:show, :edit, :update, :destroy]

  # GET /execution
  # GET /execution.json
  def index
    @execution = Execution.all
  end

  # GET /execution/1
  # GET /execution/1.json
  def show
	get_tmp_table(@execution)
  end

  # GET /execution/new
  def new
    @execution = Execution.new
  end

  # GET /execution/1/edit
  def edit
  end

  # POST /execution
  # POST /execution.json
  def create
    @execution = Execution.new(execution_params)

    respond_to do |format|
      if @execution.save
        format.html { redirect_to @execution, notice: 'Execution was successfully created.' }
        format.json { render action: 'show', status: :created, location: @execution }
      else
        format.html { render action: 'new' }
        format.json { render json: @execution.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /execution/1
  # PATCH/PUT /execution/1.json
  def update
    respond_to do |format|
      if @execution.update(execution_params)
        format.html { redirect_to @execution, notice: 'Execution was successfully updated.' }
        format.json { head :no_content }
      else
        format.html { render action: 'edit' }
        format.json { render json: @execution.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /execution/1
  # DELETE /execution/1.json
  def destroy
    @execution.destroy
    respond_to do |format|
      format.html { redirect_to execution_index_url }
      format.json { head :no_content }
    end
  end

  private
	def get_tmp_table(execution)

		sufix = "%020d" % execution.query.id

		tabulka = "tmp"+sufix

		#p(tabulka)

		ActiveRecord::Base.uncached() do
			begin
			Tmp.table_name_suffix = sufix;
			@tmptable = Tmp.find_by_sql("select * from `"+tabulka+"`;")
			rescue
			@tmptable = nil;
			end
		end
	end

    # Use callbacks to share common setup or constraints between actions.
    def set_execution
      @execution = Execution.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def execution_params
      params[:execution]
    end
end

eval3/app/controllers/query_controller.rb
class QueryController < ApplicationController
  before_action :set_query, only: [:show, :edit, :update, :destroy]

  # GET /query
  # GET /query.json
  def index
    @query = Query.all
  end

  # GET /query/1
  # GET /query/1.json
  def show
  end

  # GET /query/new
  def new
    @query = Query.new
  end

  # GET /query/1/edit
  def edit
  end

  # POST /query
  # POST /query.json
  def create
    @query = Query.new(query_params)

    respond_to do |format|
      if @query.save
        format.html { redirect_to @query, notice: 'Query was successfully created.' }
        format.json { render action: 'show', status: :created, location: @query }
      else
        format.html { render action: 'new' }
        format.json { render json: @query.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /query/1
  # PATCH/PUT /query/1.json
  def update
    respond_to do |format|
      if @query.update(query_params)
        format.html { redirect_to @query, notice: 'Query was successfully updated.' }
        format.json { head :no_content }
      else
        format.html { render action: 'edit' }
        format.json { render json: @query.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /query/1
  # DELETE /query/1.json
  def destroy
    @query.destroy
    respond_to do |format|
      format.html { redirect_to query_index_url }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_query
      @query = Query.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def query_params
      params[:query]
    end
end

eval3/app/helpers/application_helper.rb
module ApplicationHelper
end

eval3/app/helpers/definition_helper.rb
module DefinitionHelper
	def markdown2html(text)
		opt = {
			:autolink => true,
			:space_after_headers => true,
			:no_intra_emphasis => true
		}
		markdown = Redcarpet::Markdown.new(Redcarpet::Render::HTML, opt)
		markdown.render(text).html_safe
	end
end

eval3/app/helpers/execution_helper.rb
module ExecutionHelper
end

eval3/app/helpers/query_helper.rb
module QueryHelper
end

eval3/app/views/execution/_form.html.erb
<%= form_for(@execution) do |f| %>
  <% if @execution.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@execution.errors.count, "error") %> prohibited this execution from being saved:</h2>

      <ul>
      <% @execution.errors.full_messages.each do |msg| %>
        <li><%= msg %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

eval3/app/views/execution/edit.html.erb
<h1>Editing execution</h1>

<%= render 'form' %>

<%= link_to 'Show', @execution %> |
<%= link_to 'Back', execution_index_path %>

eval3/app/views/execution/index.html.erb
<h1>Listing execution</h1>

<table>
  <thead>
    <tr>
      <th></th>
      <th></th>
      <th></th>
    </tr>
  </thead>

  <tbody>
    <% @execution.each do |execution| %>
      <tr>
        <td><%= link_to 'Show', execution %></td>
        <td><%= link_to 'Edit', edit_execution_path(execution) %></td>
        <td><%= link_to 'Destroy', execution, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Execution', new_execution_path %>

eval3/app/views/execution/new.html.erb
<h1>New execution</h1>

<%= render 'form' %>

<%= link_to 'Back', execution_index_path %>

eval3/app/views/execution/show.html.erb
<p id="notice"><%= notice %></p>

  <% #debug(@execution) %>

<dl style="color:#555">
<dt>
id
</dt>
<dd>
<%= p(@execution.id) %>
</dd>
<dt>
query_id
</dt>
<dd>
<%= p(@execution.query_id) %>
</dd>
<dt>
sandbox_id
</dt>
<dd>
<%= p(@execution.sandbox_id) %>
</dd>
<dt>
start~end
</dt>
<dd>
  <%= p(@execution.start) %> ~ <%= p(@execution.end) %>
</dd>
<dt>
checksum
</dt>
<dd>
<%= p(@execution.checksum) %>
</dd>
<dt>
query
</dt>
<dd>
  <% #debug(@execution.query) %>
<code style="background: #eee">
  <%= p(@execution.query.sql) %>
</code>
</dd>
<% if @execution.error_code != 0 %>
<dt>
error
</dt>
<dd>
  <%= p(@execution.error_code) %>
  <%= p(@execution.error_msg) %>
</dd>
<%end%>
<dt>
tmptable
</dt>
<dd>
<% if @tmptable && @tmptable.first %>
<table style="border: 1px solid #000">
<tr>
<% @tmptable.first.attributes.each do |attr_name, attr_value| %>
<td><%= p attr_name %></td>
<% end %>
</tr>

<% @tmptable.each do |i|  %>
<tr>
<% i.attributes.each do |attr_name, attr_value| %>
<% if attr_name %>
<td><%= p attr_value %></td>
<% end %>
<% end %>
</tr>
<% end %>

</table>
<% end %>
</dd>
</dl>

<%= link_to 'Edit', edit_execution_path(@execution) %> |
<%= link_to 'Back', execution_index_path %>

eval3/app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Eval3</title>
  <%= stylesheet_link_tag    "application", media: "all", "data-turbolinks-track" => true %>
  <%= javascript_include_tag "application", "data-turbolinks-track" => true %>
  <%= csrf_meta_tags %>
</head>
<body>

<%= yield %>

</body>
</html>